/*
 * Projekt: C-quest
 * Autor: David Martinek (c) 2004
 * email: martinek@fit.vutbr.cz
 * Licence: GPL v.2
 * Popis: Zdrojov soubor s definic konstant a funkc pro chybov vpisy
 *        a pro vpis npovdy.
 *
 * $Id: cqhelp.c,v 1.6 2004/07/06 21:49:41 martinek Exp $
 * 
 * Copyright (C)2004 David Martinek
 *
 * Tento program je svobodn software; mete jej it a modifikovat podle
 * ustanoven GNU General Public License, vydvan Free Software
 * Foundation; a to bu verze 2 tto licence anebo (podle vaeho uven)
 * kterkoli pozdj verze.
 *
 * Tento program je roziovn v nadji, e bude uiten, avak BEZ
 * JAKKOLI ZRUKY; neposkytuj se ani odvozen zruky PRODEJNOSTI anebo
 * VHODNOSTI PRO URIT EL. Dal podrobnosti hledejte ve GNU General Public 
 * License.
 *
 * Kopii GNU General Public License jste ml obdret spolu s tmto
 * programem; pokud se tak nestalo, napite o ni Free Software Foundation,
 * Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "cqhelp.h"

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>

/** Obrazovka s verz programu. */
const char * VERSION =
"C-quest verze 1.0\n";

/** Obrazovka s hlavikou programu. */
const char * HEAD =
"Program C-quest slou pro testovn znalost o jazyce C (obecn pro\n"
"testovn libovolnch znalost)\n"
"Autor: David Martinek (c)2004\n"
"\n"
"Tento program je en pod licenc GPL verze 2, jej pln znn najdete\n"
"na webovch strnkch www.gnu.cz\n";

/** Popis spoutn a parametr programu. */
const char * PARAMS =
"Pouit programu:\n"
"  cquest [-t|l] testov_soubor\n"
"  cquest -v\n"
"  cquest -h\n"
"\n"
"Parametry:\n"
"  -v  - zobraz aktuln verzi programu\n"
"  -h  - zobraz npovdu k programu\n"
"  -t  - testovac md (implicitn)\n"
"  -l  - md uen\n";

/** Nerozpoznateln parametr. */
const char * BAD_PARAM =
"Program byl sputn neleglnm zpsobem.\n";

/** Chyba oteven souboru. */
const char * BAD_FILE =
"Zadan soubor nejde otevt. Pravdpodobn jste zadali chybn cestu\n"
"nebo nemte k souboru dostaten prva.\n";

/** Chybn formt souboru. */
const char * BAD_FORMAT =
"Zadan soubor m patn formt.\n";

/** Chyb voln pam. */
const char * NO_MEMORY =
"CHYBA! Nen dostatek voln pamti.\n";

/**
 * Vytiskne obrazovku s npovdou.
 *
 * V jin implementaci me bt vstup pesmrovn jinam.
 * 
 * @param msg Text npovdy.
 */
void printHelp(const char * msg, ...)
{
  va_list params;
  va_start(params, msg);
  vprintf(msg, params);
  va_end(params); 
}

/**
 * Vytiskne obrazovku s npovdou na chybov vstup.
 *
 * V jin implementaci me bt vstup pesmrovn jinam.
 * 
 * @param msg Text npovdy.
 */
void printError(const char * msg, ...)
{
  va_list params;
  va_start(params, msg);
  vfprintf(stderr, msg, params);
  va_end(params);
}

