#ifndef DM_CQLIST_H
#define DM_CQLIST_H
/*
 * Projekt: C-quest
 * Autor: David Martinek (c) 2004
 * email: martinek@fit.vutbr.cz
 * Licence: GPL v.2
 * Popis: Hlavikov soubor s deklarac funkc pro prci se spojovmi seznamy.
 *
 * $Id: cqlist.h,v 1.9 2004/07/12 17:30:44 martinek Exp $
 * 
 * Copyright (C)2004 David Martinek
 *
 * Tento program je svobodn software; mete jej it a modifikovat podle
 * ustanoven GNU General Public License, vydvan Free Software
 * Foundation; a to bu verze 2 tto licence anebo (podle vaeho uven)
 * kterkoli pozdj verze.
 *
 * Tento program je roziovn v nadji, e bude uiten, avak BEZ
 * JAKKOLI ZRUKY; neposkytuj se ani odvozen zruky PRODEJNOSTI anebo
 * VHODNOSTI PRO URIT EL. Dal podrobnosti hledejte ve GNU General Public 
 * License.
 *
 * Kopii GNU General Public License jste ml obdret spolu s tmto
 * programem; pokud se tak nestalo, napite o ni Free Software Foundation,
 * Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

//
// Nsledujc konstanty nanetst nejde definovat pomoc const, protoe
// se pouvaj pro alokaci a inicializaci loklnch pol.
//
/** Maximln dlka dky. */
#define LLEN 80

/** Maximln poet dk v otzce. */
#define RLEN 5

/** Poloka spojovho seznamu obsahujc data k jedn otzce. */
typedef struct item
{
  char *questLines;    /**< Text s otzkou. */
  char *answLines;     /**< dky s odpovmi oddlen znakem konce dku. */
  char *explLines;     /**< Text s vysvtlenm sprvn odpovdi. */
  char rightAnswer;    /**< Psmeno oznaujc sprvnou odpov. */
  unsigned short time; /**< Odhad asov nronosti otzky v sekundch. */
  struct item *next;   /**< Ukazatel na dal poloku seznamu. */
} TItem;

/**
 * Inicializuje strukturu TItem.
 */
//void initItem(TItem *item);

/**
 * Vytvo a inicializuje strukturu TItem a vrt ukazatel na ni.
 */
TItem *createItem(void);

/**
 * Uvoln pam ze struktury TItem. Neuvoluje samotn parametr item, protoe
 * me jt o voln odkazem. Neuvoluje ani dal prvek spojovho seznamu.
 * Uvoluje pouze data.
 */
//void freeItem(TItem *item);

/** Obsah testovho souboru. Spojov seznam zznam s testovmi otzkami. */
typedef struct testdata
{
  char *title;            /**< Text nadpisu testu. */
  unsigned int totalTime; /**< as uren pro zodpovzen vech otzek v sekundch. */
  unsigned int total;     /**< Poet vech poloek seznamu otzek. */
  TItem *first;           /**< Ukazatel na prvn poloku seznamu. */
  TItem *last;            /**< Ukazatel na posledn poloku seznamu. */
} TTestData;

/**
 * Inicializuje strukturu TTestData.
 */
void initTestData(TTestData *data);

/**
 * Vytvo a inicializuje strukturu TTestData a vrt ukazatel na ni.
 */
TTestData *createTestData(void);

/**
 * Sete asy vech poloek seznamu a ulo jej do sloky data->totalTime.
 */
void countTotalTime(TTestData *data);

/**
 * Pid dal poloku seznamu otzek.
 */
void addItem(TTestData *data, TItem *item);

/**
 * Uvoln seznam testovch otzek. Neru parametr data, protoe me jt o
 * pedvn odkazem.
 */
void freeTestData(TTestData *data);

#endif

